package org.jfw.apt.orm.core.model.where;

import org.jfw.apt.orm.core.ColumnHandler;
import org.jfw.apt.orm.core.ColumnHandlerFactory;
import org.jfw.apt.orm.core.ColumnWriterCache;
import org.jfw.apt.out.ClassWriter;

public class WhereInColumn extends WhereColumn {
	private String sqlVarName;
	private String nullableVarName;
	private String loopVarName;
	private String columnName;
	private ColumnHandler ch;
	// private String arrayLenVarName;

	public String getColumnName() {
		return columnName;
	}

	public void setColumnName(String columnName) {
		this.columnName = columnName;
	}

	@Override
	public void prepare(ClassWriter cw) {
		sqlVarName = cw.getMethodTempVarName();
		nullableVarName = cw.getMethodTempVarName();
		// arrayLenVarName = cw.getMethodTempVarName();
		loopVarName = cw.getMethodTempVarName();
		cw.bL("boolean ").w(nullableVarName).w(" = (null == ").w(this.getName()).w(") || (0 == ").w(this.getName()).el(".length);");
		cw.bL("int ").w(loopVarName).el(" = 0 ;");
		cw.bL("StringBuilder ").w(sqlVarName).el(" = null;");
		cw.bL("if(!").w(nullableVarName).el("){");
		cw.bL(sqlVarName).el(" = new StringBuilder();");
		cw.bL(sqlVarName).w(".append(\"").w(this.columnName).w(" IN (").el("\");");
		cw.bL("for( ").w(loopVarName).w(" = 0 ; ").w(loopVarName).w(" < ").w(this.getName()).w(".length; ++").w(loopVarName).el("){");
		cw.bL(sqlVarName).el(".append(\"?,\");");
		cw.l("}");
		// cw.bL("int ").w(arrayLenVarName).w(" = ").w(loopVarName).el(" ;");
		cw.bL(sqlVarName).w(".setCharAt(").w(sqlVarName).el(".length()-1,')');");
		cw.l("}");

		this.setNullable(true);

		InColumnWriterCache icwc = new InColumnWriterCache();
		this.ch = ColumnHandlerFactory.get(this.getHandlerClass());
		icwc.setColumnHandler(this.ch);
		icwc.setCw(cw);
		icwc.setCheckNullVar(nullableVarName);
		icwc.setCacheValVar(this.getName() + "[" + loopVarName + "]");
		icwc.setNullable(true);
		this.setCwc(icwc);
	}

	@Override
	public String getWhereSql() {
		ClassWriter cw = this.getCwc().getCw();
		cw.w("\").append(").w(sqlVarName).w(".toString()).append(\"");
		return "";
	}

	@Override
	public void writeValue() {
		((InColumnWriterCache) this.getCwc()).setNullable(false);
		ClassWriter cw = this.getCwc().getCw();
		cw.checkJdbcParamIndex();
		cw.bL("if(!").w(this.nullableVarName).el("){");
		cw.bL("for( ").w(loopVarName).w(" = 0 ; ").w(loopVarName).w(" < ").w(this.getName()).w(".length; ++").w(loopVarName).el("){");
		this.ch.writeValue(this.getCwc(), false);
		cw.l("}");
		cw.l("}");
	}

	public static class InColumnWriterCache extends ColumnWriterCache {
		public void setColumnHandler(ColumnHandler ch) {
			this.ch = ch;
		}

		public void setCw(ClassWriter cw) {
			this.cw = cw;
		}

		public void setCheckNullVar(String v) {
			this.checkNullVar = v;
		}

		public void setCacheValVar(String v) {
			this.cacheValVar = v;
		}

		@Override
		public boolean isUseTmpVar() {
			return true;
		}

		public void setNullable(boolean v) {
			this.nullable = v;
		}
	}

}
